#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include "font.h"

#define  X_WIDTH	57
#define  Y_WIDTH	19
#define  DOT_SIZE	15
#define  FULL_CYCLE	23040 
	
void line(d,draw,gc,x0,y0,x1,y1,rad,pat,val)
Display *d;
Window draw;
GC gc;
int x0,y0,x1,y1,rad;
float *pat,val;
{
	int x2,y2;
	if(abs(x0-x1)<=1 && abs(y0-y1)<=1){
		XFillArc (d,draw,gc,x0*rad,y0*rad,rad,rad,0,FULL_CYCLE);
		XFillArc (d,draw,gc,x1*rad,y1*rad,rad,rad,0,FULL_CYCLE);
		*(pat+y0*X_WIDTH+x0)=val;   *(pat+y1*X_WIDTH+x1)=val;
	}
	else{
		x2=(x0+x1)/2;  y2=(y0+y1)/2;
		line(d,draw,gc,x0,y0,x2,y2,rad,pat,val);
		line(d,draw,gc,x2,y2,x1,y1,rad,pat,val);
	}
}

patedit_(pat)
float *pat;
{

	Display *d;
	Window r, w, head, sw1, sw2,draw;
	GC gc;
	XEvent e;
	unsigned long color[6],color_dot;
	Font f1, f2;
	int x, y, x_width, y_width;
	int  x0, y0,x1,y1,button;
	float val;

	x_width=X_WIDTH*DOT_SIZE;
	y_width=Y_WIDTH*DOT_SIZE;

	d = XOpenDisplay (NULL);
	r = RootWindow (d, 0);

	f1 = XLoadFont (d,times240);
	f2 = XLoadFont (d,helvetica240);
	gc = XCreateGC (d, r, 0, 0);

	color[0] = WhitePixel (d, 0);
	color[1] = BlackPixel (d, 0);
	color[2] = MyColor (d, "MediumBlue" );
	color[3] = MyColor (d, "LightSlateBlue" );
	color[4] = MyColor (d, "lavender"   );
	color[5] = MyColor (d, "azure"    );

	w     = XCreateSimpleWindow
		(d, r, 0, 0, x_width+30, y_width+30+100, 2, color[3],color[4] );
	head  = XCreateSimpleWindow
		(d, w, 10, 10,x_width, 80, 5, color[3], color[4]);
	sw1 = XCreateSimpleWindow
		(d, head, 10, 10, 150, 50, 5, color[3], color[5]);
	sw2 = XCreateSimpleWindow
		(d, head,x_width-150-20, 10, 150, 50, 5, color[3], color[5]);
	draw = XCreateSimpleWindow
		(d, w,10, 90+20, x_width, y_width, 5, color[3], color[4]);

	XSelectInput(d, w,     ExposureMask);
	XSelectInput(d, head,  ExposureMask);
	XSelectInput(d,  sw1,  ExposureMask | ButtonPressMask);
	XSelectInput(d,  sw2,  ExposureMask | ButtonPressMask);
	XSelectInput(d, draw,  ExposureMask | ButtonPressMask | ButtonMotionMask);

	XMapWindow (d, w);
	XMapSubwindows (d, head);
	XMapSubwindows (d, draw);
	XMapSubwindows (d, w);

	while (1) {
	  XNextEvent (d, &e);
	  switch (e.type) {
	    case Expose:
	      XSetForeground (d, gc, color[2]);
	      XSetFont (d, gc, f1);
	      XDrawString (d, sw1, gc, 40, 35, "Clear", 5);
	      XDrawString (d, sw2, gc, 40, 35, "Exit", 4);
	      XSetFont (d, gc, f2);
	      XDrawString (d, head, gc, 300, 50, "Drawing Tool",12);
              color_dot=color[3];
              XSetForeground (d, gc, color_dot);
    	      for(y=0;y<Y_WIDTH;y++){
	         for(x=0;x<X_WIDTH;x++){
		     if((val=*(pat+y*X_WIDTH+x)) > 0.0){
                        XFillArc(d,draw,gc,x*DOT_SIZE,y*DOT_SIZE,
		   	  (int)(DOT_SIZE*val),(int)(DOT_SIZE*val),0,FULL_CYCLE);
		     } 
		 }
              }
	      XFlush(d);
	      break;
	    case ButtonPress :
	      if (e.xany.window == sw1){
		     XClearWindow (d, draw);
    	             for(y=0;y<Y_WIDTH;y++){
	               for(x=0;x<X_WIDTH;x++){
		          *(pat+y*X_WIDTH+x)=0.0;
		       } 
		     }
		     break;
	      }
	      if (e.xany.window == sw2){
		     XDestroyWindow(d,w);
		     XFlush(d);
		     return;
	      }
	      if (e.xany.window == draw)
                     x0 =e.xbutton.x/DOT_SIZE;
		     y0 =e.xbutton.y/DOT_SIZE;
		     button=e.xbutton.button;
                     if(button == 1) {
                        color_dot=color[3];
		        *(pat+y0*X_WIDTH+x0)=1.0;
                     }
                     else{
                        color_dot=color[4];
		        *(pat+y0*X_WIDTH+x0)=0.0;
                     }
                     XSetForeground (d, gc, color_dot);
                     XFillArc(d,draw,gc,x0*DOT_SIZE,y0*DOT_SIZE,
			      DOT_SIZE,DOT_SIZE,0,FULL_CYCLE);
	      break;
	    case MotionNotify :
	      if (e.xany.window == draw) {
                     x1 =e.xbutton.x/DOT_SIZE;
		     y1 =e.xbutton.y/DOT_SIZE;
		     if(button == 1) {
			color_dot=color[3];
		        val=1.0;
		     }
		     else{
			color_dot=color[4];
		        val=0.0;
		     }
	             XSetForeground (d, gc, color_dot);
		     line(d,draw,gc,x0,y0,x1,y1,DOT_SIZE,pat,val);
		     x0=x1; y0=y1;
	      }
         }
       }
}

