
C       FBNBW0.FOR  ---  FOR FBNEO0
C         ***  MODEL FOR SELECTIVE ATTENTION  ***
C       1-SPT-89       for wide version.
C         *******************************************************
C           FOR SUN WORKSTATION
C           27-MAR-90
C         *******************************************************
 
 
        SUBROUTINE RESWC(WC,WCM,WS,WSM,A,IA,B,C,RT,ALPH,
     &                   NCX,NCY,KC,NSX,NSY,KS,NA)
        PARAMETER (NCXM=28)
        PARAMETER (NCYM=9)
C                                                !!!
        REAL  WC(-NCX:NCX,-NCY:NCY,KC), WCM(KC)
        REAL  WS(-NSX:NSX,-NSY:NSY,KS), WSM(KS)
        REAL  A(-NA:NA,-NA:NA,*), B(KS)
        INTEGER  IA(KC,KS)
        REAL  C(-NA:NA,-NA:NA)
 
        REAL  WCV(-NCXM:NCXM,-NCYM:NCYM)
C                                     ! WCV=C@WSV
 
        IF (NCX .GT. NCXM)
     &        STOP 'Too small buffer for WCV in sub. BSIMP(NCX)'
        IF (NCY .GT. NCYM)
     &        STOP 'Too small buffer for WCV in sub. BSIMP(NCY)'
 
        DO 2002 N=-NCY,NCY
          DO 2001 M=-NCX,NCX
            WCV(M,N)=0.0
            DO 2000 K=1,KC
              WC(M,N,K)=0.0
 2000       CONTINUE
 2001     CONTINUE
 2002   CONTINUE
        DO 2003 K=1,KC
          WCM(K)=0.0
 2003   CONTINUE
 
        AKC=KC
        RRK=RT/((1.0+RT)*SQRT(AKC))
C                                     ! If Sigma C = 1, omit SQRT(AKC)
        DO 2008 N=-NSY,NSY
          NN1=MAX0(N-NA,-NCY)
          NN2=MIN0(N+NA,NCY)
          DO 2007 M=-NSX,NSX
            WSV=0.0
            DO 2004 KA=1,KS
              WSV=WSV+WS(M,N,KA)*B(KA)
 2004       CONTINUE
            WSV=WSV*RRK
            IF (WSV .GT. 0.0)  THEN
              MM1=MAX0(M-NA,-NCX)
              MM2=MIN0(M+NA, NCX)
                DO 2006 NN=NN1,NN2
                  DO 2005 MM=MM1,MM2
                    WCV(MM,NN)=WCV(MM,NN) + C(MM-M,NN-N)*WSV
 2005             CONTINUE
 2006           CONTINUE
            END IF
 2007     CONTINUE
 2008   CONTINUE
 
        DO 2014 KA=1,KS
          IF (WSM(KA) .GT. 0.0)  THEN
            DO 2013 N=-NSY,NSY
              NN1=MAX0(N-NA,-NCY)
              NN2=MIN0(N+NA,NCY)
              DO 2012 M=-NSX,NSX
                WWS=WS(M,N,KA)
                IF (WWS .GT. 0.0)  THEN
                  MM1=MAX0(M-NA,-NCX)
                  MM2=MIN0(M+NA, NCX)
 
                  DO 2011 K=1,KC
                    IAA=IA(K,KA)
                    IF (IAA .GT. 0)  THEN
                      DO 2010 NN=NN1,NN2
                        DO 2009 MM=MM1,MM2
                          AA=A(MM-M,NN-N,IAA)
                          IF (AA .GT. 0.0)  THEN
                            WC(MM,NN,K)=WC(MM,NN,K) + AA*WWS
                          END IF
                          IF (AA .LT. 0.0)  THEN
                            WC(MM,NN,K)=WC(MM,NN,K) + AA*WWS
                          END IF
 2009                   CONTINUE
 2010                 CONTINUE
                    END IF
 2011             CONTINUE
 
                END IF
 2012         CONTINUE
 2013       CONTINUE
          END IF
 2014   CONTINUE
 
        ALPH1=1.0/ALPH
        DO 2017 N=-NCY,NCY
          DO 2016 M=-NCX,NCX
            VV=WCV(M,N)
            IF (VV .GT. 0.0)  THEN
              DO 2015 K=1,KC
                WWC=WC(M,N,K)-VV
                IF (WWC .GT. 0.0)  THEN
                  WWC=WWC/(WWC+ALPH1)
                  WC(M,N,K)=WWC
                  IF (WCM(K) .LT. WWC)  WCM(K)=WWC
                ELSE
                  WC(M,N,K)=0.0
                END IF
 2015         CONTINUE
            END IF
 2016     CONTINUE
 2017   CONTINUE
        RETURN
        END
 
 
 
 
 
        SUBROUTINE RESWS(WS,WSM,WC,WCM,US,USM,D,ALPHWS,
     &                   NSX,NSY,KK,NCX,NCY,NT,ND)
        REAL  WS(-NSX:NSX,-NSY:NSY,KK), WSM(KK)
        REAL  WC(-NCX:NCX,-NCY:NCY,KK), WCM(KK)
        REAL  US(-NSX:NSX,-NSY:NSY,KK), USM(KK)
        REAL  D(-ND:ND,-ND:ND)
 
        DO 2008 K=1,KK
          DO 2001 N=-NSY,NSY
            DO 2000 M=-NSX,NSX
              WS(M,N,K)=0.0
 2000       CONTINUE
 2001     CONTINUE
 
          IF (WCM(K) .GT. 0.0)  GOTO 2010
          IF (WCM(K) .LT. 0.0)  GOTO 2010
          WSM(K)=0.0
          GOTO 2009
 2010     IF (USM(K) .GT. 0.0)  GOTO 2011
          IF (USM(K) .LT. 0.0)  GOTO 2011
          WSM(K)=0.0
          GOTO 2009
 
 2011     CONTINUE
            DO 2005 N=-NCY,NCY
              NNT=N*NT
              NN1=MAX0(NNT-ND,-NSY)
              NN2=MIN0(NNT+ND, NSY)
              DO 2004 M=-NCX,NCX
                WWC=WC(M,N,K)
                IF (WWC .GT. 0.0)  THEN
                  MMT=M*NT
                  MM1=MAX0(MMT-ND,-NSX)
                  MM2=MIN0(MMT+ND, NSX)
                  DO 2003 NN=NN1,NN2
                    DO 2002 MM=MM1,MM2
                      WS(MM,NN,K)=WS(MM,NN,K) + D(MM-MMT,NN-NNT)*WWC
 2002               CONTINUE
 2003             CONTINUE
                END IF
 2004         CONTINUE
 2005       CONTINUE
 
            WSMAX=0.0
            DO 2007 N=-NSY,NSY
              DO 2006 M=-NSX,NSX
                UUS=US(M,N,K)
                IF (UUS .GT. 0.0)  THEN
                  WWS=MIN( UUS, WS(M,N,K)*ALPHWS )
                  WS(M,N,K)=WWS
                  IF (WSMAX .LT. WWS)  WSMAX=WWS
                ELSE
                  WS(M,N,K)=0.0
                END IF
 2006         CONTINUE
 2007       CONTINUE
            WSM(K)=WSMAX
 
 2009     CONTINUE
 
 2008   CONTINUE
        RETURN
        END
 
 
        SUBROUTINE RESWSH(WS,WSM,WC,WCM,US,USM,ALPHWS,
     &                   NSX,NSY,KK,NCX,NCY)
        REAL  WS(-NSX:NSX,-NSY:NSY,KK), WSM(KK)
        REAL  WC(-NCX:NCX,-NCY:NCY,KK), WCM(KK)
        REAL  US(-NSX:NSX,-NSY:NSY,KK), USM(KK)
C       REAL  D(-ND:ND,-ND:ND)
 
        DO 2008 K=1,KK
          DO 2001 N=-NSY,NSY
            DO 2000 M=-NSX,NSX
              WS(M,N,K)=0.0
 2000       CONTINUE
 2001     CONTINUE
 
          IF (WCM(K) .GT. 0.0)  GOTO 2010
          IF (WCM(K) .LT. 0.0)  GOTO 2010
          WSM(K)=0.0
          GOTO 2009
 2010     IF (USM(K) .GT. 0.0)  GOTO 2011
          IF (USM(K) .LT. 0.0)  GOTO 2011
          WSM(K)=0.0
          GOTO 2009
 
 2011     CONTINUE
            DO 2005 N=-NCY,NCY
              DO 2004 M=-NCX,NCX
                WWC=WC(M,N,K)
                  DO 2003 NN=-NSY,NSY
                    DO 2002 MM=-NSX,NSX
                      WS(MM,NN,K)=WS(MM,NN,K) + 1.0*WWC
 2002               CONTINUE
 2003             CONTINUE
 2004         CONTINUE
 2005       CONTINUE
 
            WSMAX=0.0
            DO 2007 N=-NSY,NSY
              DO 2006 M=-NSX,NSX
                UUS=US(M,N,K)
                IF (UUS .GT. 0.0)  THEN
                  WWS=MIN( UUS, WS(M,N,K)*ALPHWS )
                  WS(M,N,K)=WWS
                  IF (WSMAX .LT. WWS)  WSMAX=WWS
                ELSE
                  WS(M,N,K)=0.0
                END IF
 2006         CONTINUE
 2007       CONTINUE
            WSM(K)=WSMAX
 
 2009     CONTINUE
 
 2008   CONTINUE
        RETURN
        END
 
 
 
 
 
C       SUBROUTINE RESWCH(WC,WCM,UC,UCMAX,KK)
C       REAL  WC(KK), WCM(KK)
C       REAL  UC(KK), UCMAX
CC                            ! UCMAX is not UCM!
C
C       DO 2000 K=1,KK
C         WC(K)=0.0
C          WCM(K)=0.0
C 2000  CONTINUE
C       IF (UCMAX .GT. 0.0)  THEN
C         DO 2001 K=1,KK
C           IF (UC(K) .GT. UCMAX)  GOTO 2002
C           IF (UC(K) .LT. UCMAX)  GOTO 2002
C             WC(K)=1.0
C             WCM(K)=1.0
C             GO TO 10
C 2002      CONTINUE
C 2001    CONTINUE
C 10      CONTINUE
C       END IF
C       RETURN
C       END
 
 
 
 
        SUBROUTINE RESWCH(WC,WCM,UC,UCMAX,KK)
        REAL  WC(KK), WCM(KK)
        REAL  UC(KK), UCMAX
C                             ! UCMAX is not UCM!
        UCMAX=UCMAX
        DO 2000 K=1,KK
          WC(K)=UC(K)
          WCM(K)=UC(K)
 2000   CONTINUE
        RETURN
        END
 
 
 
 
C       SUBROUTINE RESWCH(WC,WCM,UC,UCMAX,KK)
C       REAL  WC(KK), WCM(KK)
C       REAL  UC(KK), UCMAX
CC                            ! UCMAX is not UCM!
C
C       DO 2000 K=1,KK
C         WC(K)=1.0
C         WCM(K)=1.0
C 2000  CONTINUE
C       RETURN
C       END
 
 
 
 
        SUBROUTINE RESWCX(WCX,WCXM,WC,WCM,US,USM,
     &                    DD,NCX,NCY,KK,NSX,NSY,NT,NDD)
        REAL  WCX(-NCX:NCX,-NCY:NCY,KK), WCXM(KK)
        REAL  WC(-NCX:NCX,-NCY: NCY,KK), WCM(KK)
        REAL  US(-NSX:NSX,-NSY:NSY,KK), USM(KK)
        REAL  DD(-NDD:NDD,-NDD:NDD)
 
        IF (NT.GT.2)  STOP  'Sub. RESWCX cannot be used for NT>2'
        NODD=NT-1
C                                    ! Only for NT=1 or 2
        NCXT=NCX*NT
        NCYT=NCY*NT
 
        DO 2010 K=1,KK
          IF (WCM(K) .GT. 0.0)  GOTO 2013
          IF (WCM(K) .LT. 0.0)  GOTO 2013
            WCXM(K)=0.0
            DO 2001 N=-NCY,NCY
              DO 2000 M=-NCX,NCX
                WCX(M,N,K)=0.0
 2000         CONTINUE
 2001       CONTINUE
          GOTO 2014
 
 2013     CONTINUE
 
            DO 2003 N=-NCY,NCY
              DO 2002 M=-NCX,NCX
                WCX(M,N,K)=WC(M,N,K)
 2002         CONTINUE
 2003       CONTINUE
            IF (USM(K) .GT. 0.0)  GOTO 2011
            IF (USM(K) .LT. 0.0)  GOTO 2011
              WCXM(K)=WCM(K)
            GOTO 2012
 
 2011       CONTINUE
 
              DO 2007 N=-NSY,NSY
                NN1=MAX0(N-NDD,-NCYT)
                IF (AND(NN1,NODD) .NE. 0)  NN1=NN1+1
C                                                             !
                NN2=MIN0(N+NDD,NCYT)
                DO 2006 M=-NSX,NSX
                  UU=US(M,N,K)
                  IF (UU .GT. 0.0)  THEN
                    MM1=MAX0(M-NDD,-NCXT)
                    IF (AND(MM1,NODD) .NE. 0)  MM1=MM1+1
C                                                             !
                    MM2=MIN0(M+NDD,NCXT)
                    DO 2005 NNT=NN1,NN2,NT
                      NN=NNT/NT
                      DO 2004 MMT=MM1,MM2,NT
                        MM=MMT/NT
                        WCX(MM,NN,K)=WCX(MM,NN,K) -DD(M-MMT,N-NNT)*UU
 2004                 CONTINUE
 2005               CONTINUE
                  END IF
 2006           CONTINUE
 2007         CONTINUE
 
              WCXMAX=0.0
              DO 2009 N=-NCY,NCY
                DO 2008 M=-NCX,NCX
                  WW=WCX(M,N,K)
                  IF (WW .LT. 0.0)  THEN
                    WCX(M,N,K)=0.0
                  ELSE
                    IF (WW .GT. WCXMAX)  WCXMAX=WW
                  END IF
 2008           CONTINUE
 2009         CONTINUE
              WCXM(K)=WCXMAX
 
 2012       CONTINUE
 2014     CONTINUE
 2010   CONTINUE
        RETURN
        END
 
 
 
 
        SUBROUTINE RESXS(XS,WCX,WCXM,D,BETA0,BETA1,
     &                   NSX,NSY,KK,NCX,NCY,NT,ND)
        REAL  XS(-NSX:NSX,-NSY:NSY,KK)
        REAL  WCX(-NCX:NCX,-NCY:NCY,KK), WCXM(KK)
        REAL  D(-ND:ND,-ND:ND)
 
        DO 2006 K=1,KK
          DO 2001 N=-NSY,NSY
            DO 2000 M=-NSX,NSX
              XS(M,N,K)=XS(M,N,K)*BETA0
 2000       CONTINUE
 2001     CONTINUE
 
          IF (WCXM(K) .GT. 0.0)  THEN
            DO 2005 N=-NCY,NCY
              NNT=N*NT
              NN1=MAX0(NNT-ND,-NSY)
              NN2=MIN0(NNT+ND, NSY)
              DO 2004 M=-NCX,NCX
                WW=WCX(M,N,K)
                WW=WW*BETA1
                IF (WW .GT. 0.0)  THEN
                  MMT=M*NT
                  MM1=MAX0(MMT-ND,-NSX)
                  MM2=MIN0(MMT+ND, NSX)
                  DO 2003 NN=NN1,NN2
                    DO 2002 MM=MM1,MM2
                      XS(MM,NN,K)=XS(MM,NN,K) + D(MM-MMT,NN-NNT)*WW
 2002               CONTINUE
 2003             CONTINUE
                END IF
 2004         CONTINUE
 2005       CONTINUE
          END IF
 
 2006   CONTINUE
        RETURN
        END
 
 
 
 
 
        SUBROUTINE RESXX(XX,UCMAX,BETX0,BETX1,LH,IW)
        REAL  XX(LH), BETX0(LH), BETX1(LH)
        REAL  UCMAX
C                     ! UCMAX is not UCM!
 
        DO 2000 L=1,LH
          IF (UCMAX .GT. 0.0)  GOTO 2001
          IF (UCMAX .LT. 0.0)  GOTO 2001
            XX(L)=XX(L) + BETX0(L)
          GOTO 2002
 
 2001     XX(L)=XX(L) * BETX1(L)
 
 2002     CONTINUE
 2000   CONTINUE
        IF (IW .GT. 0)  WRITE (IW,1001)  (XX(L), L=1,LH)
 1001   FORMAT (1H0,'XX:',5F11.3)
        RETURN
        END
