C       FBNDK0.FOR   ---  FOR  FBNEO0
C         ***  MODEL FOR SELECTIVE ATTENTION  ***
C       7-DEC-88
C         *******************************************************
C           FOR SUN WORKSTATION
C           27-MAR-90
C         *******************************************************
 
        SUBROUTINE RWDISK(FILENUM,A,IA,B,IAMAX,KC,KS,NA,L,IRWDK)
C        ***  Read/Write Coefficients on the Disk  ***
C        ***  IRWDK=0:   WRITE DISK   ***
C        ***  IRWDK=1:   READ DISK    ***
 
        REAL     A(-NA:NA,-NA:NA,*), B(KS)
        INTEGER  IA(KC,KS)
        INTEGER  IU/4/
        INTEGER  ERRCODE,FILENUM,NUM1,NUM2
        CHARACTER DNAME*50
        CHARACTER  LN(10)/'0','1','2','3','4','5','6','7','8','9'/
        CHARACTER*3  DTYPE, DNEW/'NEW'/, DOLD/'OLD'/
        DNAME='fbnc  . '
        NUM2=FILENUM/10
        NUM1=FILENUM-NUM2*10
        DNAME(5:5)=LN(NUM2+1)
        DNAME(6:6)=LN(NUM1+1)
        DNAME(8:8)=LN(L+1)
        IF (IRWDK .GT. 0)  THEN
          DTYPE=DOLD
        ELSE
          DTYPE=DNEW
        END IF
        OPEN (UNIT=IU,IOSTAT=ERRCODE,ERR=2002,FILE=DNAME,
     &        STATUS='UNKNOWN',ACCESS='SEQUENTIAL',FORM='FORMATTED')
 
        IF (IRWDK .GT. 0)  THEN
 1001     FORMAT (I4)
          READ (IU,1001)  IAMAX
 1002     FORMAT (10I4)
          READ (IU,1002)  IA
 1003     FORMAT (5E14.7)
          READ (IU,1003)  B
          DO 2000 K=1,IAMAX
            READ (IU,1003)  ((A(M,N,K), M=-NA,NA), N=-NA,NA)
 2000     CONTINUE
        ELSE
          WRITE (IU,1001)  IAMAX
          WRITE (IU,1002)  IA
          WRITE (IU,1003)  B
          DO 2001 K=1,IAMAX
            WRITE (IU,1003)  ((A(M,N,K), M=-NA,NA), N=-NA,NA)
 2001   CONTINUE
        END IF
        CLOSE (UNIT=IU)
        RETURN
 
 2002   WRITE (*,*) '<RWDISK> OPEN ERROR :FILENAME=',
     &               DNAME,' :CODE=',ERRCODE
        STOP 
        END
 
 
C       SUBROUTINE WDK(IT,UC,WC,NN,UCH,KK,IWDK)
C       ***  Write Disk for Digital Scanner and for JCC Graphics.    ***
C       ***  FBNA%%.DAT made by this sub. is used for JCC Graphics.  ***
C       ***  It can also be transmitted to PDP-11 via PC-9800,       ***
C       ***         and then used for Digital Scanner.               ***
C       ***     Hoever, some modification is necessary               ***
C       ***                   in SEND.FOR and in PDP programs.       ***
C
C       REAL  UC(-NN:NN,-NN:NN),  WC(-NN:NN,-NN:NN)
C       REAL  UCH(KK)
C       DATA  INIT/1/
C       CHARACTER  DNAME*50
C       DNAME='/FUKUSHIMA$NEOCOG/IMA$IMA/FBNA%%.DAT'
C       INTEGER  ERRCODE
C
C       NN1=NN*2+1
C2001   FORMAT (I2)
C       WRITE (DNAME(5:6),2001)  IWDK
C       IF (INIT .EQ. 1)  THEN
C         CALL LIB$GET-LUN(IU)
C                                 ! Unit Number for FBNA%%.DAT
C         OPEN (UNIT=IU, IOSTAT=ERRCODE, ERR=2002, FILE=DNAME, STATUS=
C    &          'NEW',ACCESS='SEQUENTIAL', FORM='FORMATTED')
C         INIT=0
C       END IF
C
C 1001  FORMAT(I5,(8Z8.8))
C1001   FORMAT(I10,(6F10.7))
C       WRITE (IU,1001)  IT, UCH
C       DO 2000 N=-NN,NN
C 1002    FORMAT(7Z8.8)
C1002     FORMAT(7F10.7)
C         WRITE (IU,1002)  (UC(M,N), M=-NN,NN)
C2000   CONTINUE
C
C       WRITE (IU,1001)  IT, UCH
C       DO 2003 N=-NN,NN
C         WRITE (IU,1002)  (WC(M,N), M=-NN,NN)
C2003   CONTINUE
C       RETURN
C
C2002   WRITE (*,*) '<WDK> OPEN ERROR :FILENAME=',DNAME,' :CODE=',ERRCODE
C       STOP
C
C       END
C       FBNPR0.FOR  ---  FOR FBNEO0
C         ***  MODEL FOR SELECTIVE ATTENTION  ***
C       1-AUG-86
C
C
        SUBROUTINE PRINT(U,MM,NN,KK,TIL,IL,IW)
        PARAMETER  (KKMAX=40)
        REAL     U(-MM:MM,-NN:NN,KK),  UM(KKMAX)
        CHARACTER*3  TITLE
        INTEGER      ISQ(KKMAX)
        INTEGER   TIL
        CHARACTER*3 TIE(1:12) /'U0 ','UC ','US ','WC ','WS ','G1 ',
     &                         'WCX','XS ','GHB','A  ','B  ','G2 '/
        CHARACTER*1  L(132)
        CHARACTER*1  LP(0:10)
     &                /'0','1','2','3','4','5','6','7','8','9','X'/
 
 
C       CHARACTER FMT1*41 /'(1H0,A   ,'   ',I1,' ',10X,
C    &                          '     ',F11.7)'/
CCC1001 FORMAT (1H0,A<LENT>,'(L=',I1,')',10X,'MAX =',F11.7)
 
C        CHARACTER FMT2*21 /'(1H0,4X,62(I2,:,  X))'/
CCC1003 FORMAT (1H0,4X,62(I2,:,<MPITCH-2>X))
 
C        CHARACTER FMT3*21 /'(1X,5X,62(  I1,:,1X))'/
CCC1004 FORMAT (1X,5X,62(<MWIDTH>I1,:,1X))
 
C        CHARACTER FMT4*19 /'(1X,I4,1H*,  A1,I1)'/
CCC1006 FORMAT (1X,I4,'*',<ML>A1,I1)
 
C        CHARACTER FMT5*16 /'(1X,4X,1H*,  A1)'/
CCC1016 FORMAT (1X,4X,'*',<ML>A1)
 
C        CHARACTER FMT6*16 /'(1X,4X,36F  .  )'/
CCC1007 FORMAT (1X,4X,36F<MPITCH>.<ND>)
 
 
        TITLE=TIE(TIL)
        IF (IW .LE. 0)  RETURN
        IF (KK.GT.KKMAX)  STOP 'Too small buffer ISQ in sub. FBNPR0'
 
        KSQ=0
        UMAX=0.0
        DO 2002 K=1,KK
          UMK=0.0
          DO 2001 N=-NN,NN
            DO 2000 M=-MM,MM
              IF (UMK .LT. U(M,N,K))  UMK=U(M,N,K)
 2000       CONTINUE
 2001     CONTINUE
          UM(K)=UMK
          IF (UMK .GT. 0.0)  THEN
            IF (UMAX .LT. UMK)  UMAX=UMK
            KSQ=KSQ+1
            ISQ(KSQ)=K
          END IF
 2002   CONTINUE
 
C       LENT=LEN(TITLE)
C       ENCODE(FMT1(7:9),'(I3)') LENT
        WRITE (IW,1001)  TITLE, IL, UMAX
 1001   FORMAT (A3,'(L=',I1,')',10X,'MAX =',F11.7)
C1001   FORMAT (1H0,A<LENT>,'(L=',I1,')',10X,'MAX =',F11.7)
        IF (UMAX .LE. 0.0)  THEN
          WRITE (IW,1002)
 1002     FORMAT (2X,'All elements are zero!')
          RETURN
        END IF
 
        UM0=UMAX*0.01
        IF (IW .EQ. 1)  THEN
            NCPL=124
C                          ! 124=132-8
          ELSE
            NCPL=72
C                          ! 72=80-8
          END IF
        MWIDTH=MM*2+1
        MPITCH=MWIDTH+1
        KMM=NCPL/MPITCH
 
C       ENCODE(FMT2(17:18),'(I2)') MPITCH-2
C       ENCODE(FMT3(11:12),'(I2)') MWIDTH
C       ENCODE(FMT6(11:12),'(I2)') MPITCH
 
        DO 2006 KM1=1,KSQ,KMM
          KM2=MIN0(KM1+KMM-1, KSQ)
          IF (KK.GT.1)  THEN
            IF (NN.GT.0)  THEN
              WRITE (IW,1003)  (ISQ(KM), KM=KM1,KM2)
 1003         FORMAT (4X,62(I2,:,<MPITCH-2>X))
            ELSE
              WRITE (IW,1013)  (ISQ(KM), KM=KM1,KM2)
 1013         FORMAT (4X,62I2)
            END IF              
          END IF
          IF (NN.GT.0)  WRITE (IW,1004)
     &                   ((MOD(IABS(M),10), M=-MM,MM), KM=KM1,KM2)
 1004     FORMAT (1X,5X,62(<MWIDTH>I1,:,1X))
          WRITE (IW,1005)  (' ', ('*', M=-MM,MM), KM=KM1,KM2)
 1005     FORMAT (1X,4X,128A1)
          DO 2005 N=-NN,NN
            ML=0
            DO 2004 KM=KM1,KM2
              ISQK=ISQ(KM)
              DO 2003 M=-MM,MM
                ML=ML+1
                UU=U(M,N,ISQK)
                IF (UU .GT. 0.0)  GOTO 2007
                IF (UU .LT. 0.0)  GOTO 2007
                  L(ML)=' '
                GOTO 2008
 
 2007           IF (UU .LT. 0.0)  THEN
                  L(ML)='-'
                ELSE IF (UU .LE. UM0)  THEN
                  L(ML)='.'
                ELSE IF (UU .GT. UMAX)  THEN
                  L(ML)='+'
                ELSE
                  L(ML)=LP(INT(10.0*(UU/UMAX)))
                END IF
 2008           CONTINUE
 2003         CONTINUE
              ML=ML+1
              L(ML)='*'
 2004       CONTINUE
C           ENCODE(FMT4(12:13),'(I2)') ML
C           ENCODE(FMT5(12:13),'(I2)') ML
            IF (NN.GT.0)  THEN
              WRITE (IW,1006)  N, (L(M), M=1,ML), MOD(IABS(N),10)
 1006         FORMAT (1X,I4,'*',<ML>A1,I1)
            ELSE
              WRITE (IW,1016)  (L(M), M=1,ML)
 1016         FORMAT (1X,4X,'*',<ML>A1)
            END IF
 2005     CONTINUE
          WRITE (IW,1005)  (' ', ('*', M=-MM,MM), KM=KM1,KM2)
          IF (NN.GT.0)  WRITE (IW,1004)
     &                   ((MOD(IABS(M),10), M=-MM,MM), KM=KM1,KM2)
          ND=MIN0(7, MPITCH-3)
C         ENCODE(FMT6(14:15),'(I2)') ND
          IF ((KK.GT.1) .AND. (ND.GT.0))  THEN
            WRITE (IW,1007)  (UM(ISQ(KM)), KM=KM1,KM2)
 1007       FORMAT (1X,4X,36F<MPITCH>.<ND>)
          END IF
 2006   CONTINUE
        RETURN
        END
 
 
 
 
 
 
        SUBROUTINE PRICLH(UC,KC,TIL,IL,IW)
        REAL         UC(KC)
        INTEGER      TIL
        CHARACTER*3  TIE(1:9) /'U0 ','UC ','US ','WC ','WS ','G  ',
     &                         'WCX','XS ','GHB'/
        CHARACTER*1  L(40)
        CHARACTER*1  LP(0:10)
     &               /'0','1','2','3','4','5','6','7','8','9','X'/
 
C       CHARACTER FMT1*13 /'(1H0,7X,  I3)'/
C       CHARACTER FMT2*18 /'(1H0,7X,  (2X,A1))'/
C  1001 FORMAT (1H0,A<LENT>,'(L=',I1,')',1X,10X,'MAX =',F11.7/
C    &          1X,4X,'K:   ',<KC>I3/1X,9X,<KC>(2X,A1))
 
        IF (IW .LE. 0)  RETURN
 
        UCMAX=0.0
        DO 2000 K=1,KC
          IF (UC(K) .GT. UCMAX)  UCMAX=UC(K)
 2000   CONTINUE
        DO 2001 K=1,KC
          UUC=UC(K)
          IF (UUC .GT. 0.0)  GOTO 2002
          IF (UUC .LT. 0.0)  GOTO 2002
            L(K)=' '
          GOTO 2003
 
 2002     IF (UUC .LT. 0.0)  THEN
            L(K)='-'
          ELSE IF (UUC .GT. UCMAX)  THEN
            L(K)='+'
          ELSE IF ((UCMAX .GE. 0.0) .AND. (UCMAX .LE. 0.0)) THEN
C         ELSE IF (UCMAX .EQ. 0.0) THEN
            L(K)=LP(10)
          ELSE
            L(K)=LP(INT(10.0*(UUC/UCMAX)))
          END IF
 2003     CONTINUE
 2001   CONTINUE
C       ENCODE(FMT1( 9:10),'(I2)') KC
C       ENCODE(FMT2( 9:10),'(I2)') KC
C       WRITE (IW,1001)  TIE(TIL), IL, UCMAX
C       WRITE (IW,FMT1)  (K, K=0,KC-1)
C       WRITE (IW,1002)  'K   ='
C       WRITE (IW,FMT2)  (L(K), K=1,KC)
C       WRITE (IW,1002)  'L(K)='
C1001   FORMAT (1H0,A3,'(L=',I1,')',5X,'MAX =',F11.7)
C1002   FORMAT (1H+,A5)
        WRITE(IW,1001) TIE(TIL),IL,UCMAX,
     &                 (K,K=1,KC),(L(K),K=1,KC)
 1001   FORMAT (A<LENT>,'(L=',I1,')',1X,10X,'MAX =',F11.7/
     &          1X,4X,'K:   ',<KC>I3/1X,9X,<KC>(2X,A1))

        RETURN
        END
 
