C      FBNFW0.FOR  ---  FOR FBNEO0
C         ***  MODEL FOR SELECTIVE ATTENTION  ***
C       02-FEB-90   for  wide  version
C         *******************************************************
C           FOR SUN WORKSTATION
C           can control gain
C           X can be different from Y
C           USE G for MASKING !!!
C           27-MAR-90
C         *******************************************************
C
        SUBROUTINE LATUS(US,USM,ELAT,NSX,NSY,KS,NELAT)
        PARAMETER (NSXM=28)
        PARAMETER (NSYM= 9)
C                                                !!!
        REAL  US(-NSX:NSX,-NSY:NSY,KS), USM(KS)
        REAL  ELAT(-NELAT:NELAT,-NELAT:NELAT,2)
 
        REAL  W(-NSXM:NSXM,-NSYM:NSYM)
        REAL  H(-NSXM:NSXM,-NSYM:NSYM)
 
        IF (NSX .GT. NSXM)
     &        STOP 'Too small buffer in sub. SIMPLE(NSX)'
        IF (NSY .GT. NSYM)
     &        STOP 'Too small buffer in sub. SIMPLE(NSY)'
 
        DO 10 I=1,2
 
        DO 2002 N=-NSY,NSY
          DO 2001 M=-NSX,NSX
            UU=0.0
            DO 2000 K=1,KS
              UU=UU+US(M,N,K)
 2000       CONTINUE
            W(M,N)=UU
 2001     CONTINUE
 2002   CONTINUE
 
        DO 2011 K=1,KS
          DO 2004 N=-NSY,NSY
            DO 2003 M=-NSX,NSX
              H(M,N)=US(M,N,K)
 2003       CONTINUE
 2004     CONTINUE
 
          DO 2008 N=-NSY,NSY
            NN1=MAX0(N-NELAT,-NSY)
            NN2=MIN0(N+NELAT,NSY)
            DO 2007 M=-NSX,NSX
              WW=W(M,N)
 
              IF (WW .GT. 0.0)  THEN
                MM1=MAX0(M-NELAT,-NSX)
                MM2=MIN0(M+NELAT,NSX)
                UU=US(M,N,K)
                DO 2006 NN=NN1,NN2
                  DO 2005 MM=MM1,MM2
                    H(MM,NN)=H(MM,NN) - ELAT(M-MM,N-NN,1)*UU
     &                                - ELAT(M-MM,N-NN,2)*(WW-UU)
 2005             CONTINUE
 2006           CONTINUE
              END IF
 
 2007       CONTINUE
 2008     CONTINUE
 
          USM(K)=0.0
          DO 2010 N=-NSY,NSY
            DO 2009 M=-NSX,NSX
              UU=H(M,N)
              IF (UU .LT. 0.0)  UU=0.0
              US(M,N,K)=UU
              IF (USM(K) .LT. UU)  USM(K)=UU
 2009       CONTINUE
 2010     CONTINUE
 
 2011   CONTINUE
 
 10     CONTINUE
 
        RETURN
        END
 
 
 
 
 
        SUBROUTINE RESUS(US,USM,UC,UCM,XS,XX,A,IA,B,C,RT,SIG,
     &                   NSX,NSY,KS,NCX,NCY,KC,NA)
        PARAMETER (NSXM=28)
        PARAMETER (NSYM= 9)
C                                                !!!
        REAL  US(-NSX:NSX,-NSY:NSY,KS), USM(KS)
        REAL  UC(-NCX:NCX,-NCY:NCY,KC), UCM(KC)
        REAL  XS(-NSX:NSX,-NSY:NSY,KS)
        REAL  A(-NA:NA,-NA:NA,*), B(KS)
        INTEGER  IA(KC,KS)
        REAL  C(-NA:NA,-NA:NA)
 
        REAL  USV2(-NSXM:NSXM,-NSYM:NSYM)
 
        IF (NSX .GT. NSXM)
     &        STOP 'Too small buffer for USV2 in sub. SIMPLE(NSX)'
        IF (NSY .GT. NSYM)
     &        STOP 'Too small buffer for USV2 in sub. SIMPLE(NSY)'
 
        DO 2002 K=1,KS
          DO 2001 N=-NSY,NSY
            DO 2000 M=-NSX,NSX
              US(M,N,K)=0.0
 2000       CONTINUE
 2001     CONTINUE
          USM(K)=0.0
 2002   CONTINUE
        DO 2004 N=-NSY,NSY
          DO 2003 M=-NSX,NSX
            USV2(M,N)=0.0
 2003     CONTINUE
 2004   CONTINUE
 
        DO 2012 KA=1,KC
          IF (UCM(KA) .GT. 0.0)  THEN
            DO 2011 N=-NCY,NCY
              NN1=MAX0(N-NA,-NSY)
              NN2=MIN0(N+NA,NSY)
              DO 2010 M=-NCX,NCX
                UU=UC(M,N,KA)
                IF (UU .GT. 0.0)  THEN
                  UU2=UU**2
                  MM1=MAX0(M-NA,-NSX)
                  MM2=MIN0(M+NA, NSX)
 
                  DO 2006 NN=NN1,NN2
                    DO 2005 MM=MM1,MM2
                      USV2(MM,NN)=USV2(MM,NN) + C(M-MM,N-NN)*UU2
 2005               CONTINUE
 2006             CONTINUE
 
                  DO 2009 K=1,KS
                    IAA=IA(KA,K)
                    IF (IAA .GT. 0)  THEN
                      DO 2008 NN=NN1,NN2
                        DO 2007 MM=MM1,MM2
                          AA=A(M-MM,N-NN,IAA)
                          IF (AA .GT. 0.0)  THEN
                            US(MM,NN,K)=US(MM,NN,K) + AA*UU
                          END IF
                          IF (AA .LT. 0.0)  THEN
                            US(MM,NN,K)=US(MM,NN,K) + AA*UU
                          END IF
 2007                   CONTINUE
 2008                 CONTINUE
                    END IF
 2009             CONTINUE
 
                END IF
 2010         CONTINUE
 2011       CONTINUE
          END IF
 2012   CONTINUE
 
        XX1=1.0+XX
        DO 2015 N=-NSY,NSY
          DO 2014 M=-NSX,NSX
            VV=USV2(M,N)
            IF (VV .GT. 0.0)  THEN
              USV=SQRT(VV)
              DO 2013 K=1,KS
                UU=US(M,N,K)
                IF (UU .GT. 0.0)  THEN
                  R = RT / (XX1 + XS(M,N,K))
                  RR=R/(1.0+R)
                  UUS=R * DIM((SIG+UU)/(SIG+RR*B(K)*USV), 1.0)
                  US(M,N,K)=UUS
                  IF (USM(K) .LT. UUS)  USM(K)=UUS
                END IF
 2013         CONTINUE
            END IF
 2014     CONTINUE
 2015   CONTINUE
        RETURN
        END
 
 
 
 
 
        SUBROUTINE RESUC(UC,UCM,US,USM,D,ALPHD,NCX,NCY,
     &                   KK,NSX,NSY,NT,ND)
        REAL  UC(-NCX:NCX,-NCY:NCY,KK), UCM(KK)
        REAL  US(-NSX:NSX,-NSY:NSY,KK), USM(KK)
        REAL  D(-ND:ND,-ND:ND)
 
        IF (NT.GT.2)  STOP  'Sub. RESUC cannot be used for NT>2'
        NODD=NT-1
C                                    ! Only for NT=1 or 2
        NCXT=NCX*NT
        NCYT=NCY*NT
 
        ALPHD1=1.0/ALPHD
        DO 2008 K=1,KK
          DO 2001 N=-NCY,NCY
            DO 2000 M=-NCX,NCX
              UC(M,N,K)=0.0
 2000       CONTINUE
 2001     CONTINUE
 
          IF (USM(K) .GT. 0.0)  GOTO 2009
          IF (USM(K) .LT. 0.0)  GOTO 2009
            UCM(K)=0.0
          GOTO 2010
 
 2009       DO 2005 N=-NSY,NSY
              NN1=MAX0(N-ND,-NCYT)
              IF (AND(NN1,NODD) .NE. 0)  NN1=NN1+1
C                                                           !
              NN2=MIN0(N+ND,NCYT)
              DO 2004 M=-NSX,NSX
                UU=US(M,N,K)
                IF (UU .GT. 0.0)  THEN
                  MM1=MAX0(M-ND,-NCXT)
                  IF (AND(MM1,NODD) .NE. 0)  MM1=MM1+1
C                                                           !
                  MM2=MIN0(M+ND,NCXT)
                  DO 2003 NNT=NN1,NN2,NT
                    NN=NNT/NT
                    DO 2002 MMT=MM1,MM2,NT
                      MM=MMT/NT
                      UC(MM,NN,K)=UC(MM,NN,K) + D(M-MMT,N-NNT)*UU
 2002               CONTINUE
 2003             CONTINUE
                END IF
 2004         CONTINUE
 2005       CONTINUE
 
            UCMAX=0.0
            DO 2007 N=-NCY,NCY
              DO 2006 M=-NCX,NCX
                UUC=UC(M,N,K)
                IF (UUC .GT. 0.0)  THEN
                  UUC= UUC/(ALPHD1+UUC)
                  UC(M,N,K)=UUC
                END IF
 2006         CONTINUE
 2007       CONTINUE
 
 2010     CONTINUE
 
 2008   CONTINUE
        RETURN
        END
 
 
 
 
 
        SUBROUTINE RESUCH(UC,UCMAX,US,USM,ALPHD,KK,NSX,NSY)
C       SUBROUTINE RESUCH(UC,UCMAX,US,USM,G,D,ALPHD,KK,NSX,NSY,ND)
        REAL  UC(KK), UCMAX
C                             ! UCMAX is not UCM!
        REAL  US(-NSX:NSX,-NSY:NSY,KK), USM(KK)
C  **** Difference between the original & this wide version for ATT. ****
C       All weights(matrix D) between USH & UCH are set with value of 1.0,
C       and a cell in K'th layer of USH conects with all cells in 
C       K'th layer of UCH.
C       REAL  D(-ND:ND,-ND:ND)
 
        UCMAX=UCMAX
C       IF (NS.NE.ND)  STOP 'NS=ND is requested in sub. COMPLD'
 
        ALPHD1=1.0/ALPHD
        UCMAX=0.0
        DO 2002 K=1,KK
          IF (USM(K) .GT. 0.0)  THEN
            UUC=0.0
            DO 2001 N=-NSY,NSY
              DO 2000 M=-NSX,NSX
                UU=US(M,N,K)
                IF (UU .GT. 0.0)  UUC=UUC + 1.0*UU
 2000         CONTINUE
 2001       CONTINUE
            IF (UUC .GT. 0.0)  THEN
              UUC=UUC/(ALPHD1+UUC)
              IF (UUC .GT. UCMAX)  UCMAX=UUC
            END IF
            UC(K)=UUC
          ELSE
            UC(K)=0.0
          END IF
 2002   CONTINUE
        RETURN
        END
 
 
 
 
        SUBROUTINE GAIN(G1,G2,WC,WCM,GAM0,GAM1,GAM2,GAM3,
     &                  NCX,NCY,KC)
        REAL  G1(-NCX:NCX,-NCY:NCY,KC)
        REAL  G2(-NCX:NCX,-NCY:NCY,KC)
        REAL  WC(-NCX:NCX,-NCY:NCY,KC), WCM(KC) , WWC
 
        DO 2004 K=1,KC
          IF (WCM(K) .GT. 0.0) THEN      
            DO 2001 N=-NCY,NCY
              DO 2000 M=-NCX,NCX
                WWC=WC(M,N,K)
                IF(WWC .LE. 0.0) THEN
                  G1(M,N,K)=GAM2*G1(M,N,K) 
                  G2(M,N,K)=GAM3*G2(M,N,K)
                ELSE
                  G1(M,N,K)=GAM0*G1(M,N,K)+(1.0-GAM0)*WWC
                  G2(M,N,K)=GAM1*G2(M,N,K)+(1.0-GAM1)*WWC
                END IF
 2000         CONTINUE
 2001       CONTINUE
          ELSE
            DO 2003 N=-NCY,NCY
              DO 2002 M=-NCX,NCX
                G1(M,N,K)=GAM2*G1(M,N,K)
                G2(M,N,K)=GAM3*G2(M,N,K)
 2002         CONTINUE
 2003       CONTINUE 
          END IF
 2004   CONTINUE
        RETURN
        END
 
 
 
        SUBROUTINE RESU0(UC,WC,P,NCX,NCY)
        REAL  UC(-NCX:NCX,-NCY:NCY)
        REAL  WC(-NCX:NCX,-NCY:NCY)
        REAL   P(-NCX:NCX,-NCY:NCY)
 
        DO 2001 N=-NCY,NCY
          DO 2000 M=-NCX,NCX
            UU = MAX(P(M,N), WC(M,N))
            UC(M,N)=UU
 2000     CONTINUE
 2001   CONTINUE
        RETURN
        END
 
 
 
 
C  ---  decision of fixpoint ---
        SUBROUTINE ATTCTRL(UC,WC,NCX,NCY,KK,FIXX,LIMIT,SMAX)
        PARAMETER(NCXMAX=28)
        REAL  UC(-NCX:NCX,-NCY:NCY,KK)
        REAL  WC(-NCX:NCX,-NCY:NCY,KK)
        REAL  SUM(-NCXMAX:NCXMAX)
        REAL  FIXX,SUMY,SUMALL,SUMMAX,SS,SMAX
        INTEGER  NCX,NCY,KK,MM
 
 
          SUMALL=0.0
          DO 1002 M=-NCX,NCX
            SUMY=0.0
            DO 1003 N=-NCY,NCY
              DO 1009 K=1,KK
                SUMY=SUMY+UC(M,N,K)
 1009         CONTINUE
 1003       CONTINUE
            SUMALL=SUMALL+SUMY
            SUM(M)=SUMY
 1002     CONTINUE
 
          write(*,*) "SUMALL=",SUMALL
C         **************
          DO 1004 M=-NCX+2,NCX-2
            SUM(M)=(SUM(M-2)+SUM(M+2))+(SUM(M-1)+SUM(M+1))+SUM(M)
            SUM(M)=SUM(M)/5.0
 1004     CONTINUE
          SUMALL=0.0
          DO 1007 M=-NCX+2,NCX-2
            SUM(M)=(SUM(M-2)+SUM(M+2))+(SUM(M-1)+SUM(M+1))+SUM(M)
            SUM(M)=SUM(M)/5.0
            SUMALL=SUMALL+SUM(M)
 1007     CONTINUE
          SUM(-NCX  )=SUM(-NCX+2)
          SUM(-NCX+1)=SUM(-NCX+2)
          SUM( NCX  )=SUM( NCX-2)
          SUM( NCX-1)=SUM( NCX-2)
          SUMALL=SUMALL/(NCX*2-3)
 
C         DO 1008 M=-NCX,NCX              TO REDUCE AVERAGE
C           SUM(M)=DIM(SUM(M)-SUMALL,0.0)
C1008     CONTINUE
          SUMMAX=-100.0
          DO 1006 M=-NCX ,NCX

C  pattern on the left is easy to be attended !
C            SS=(REAL(NCX-M)/REAL(NCX*2)*0.5+1.0)*SUM(M)

C  all patterns have a chance to be attended
             SS=SUM(M) 

             IF(SS .GT. SUMMAX) THEN
               MM=M
               SUMMAX=SS
             END IF
 1006     CONTINUE
          write(*,*) "SUMMAX=",SUMMAX
	  SMAX=SUMMAX
          FIXX=REAL(MM)/REAL(NCX)
 
        RETURN
        END
 
 
C   --- use-dependent gain ---
        SUBROUTINE GAINP(UC,G1,G2,AMP,NCX,NCY,KK)
        REAL  UC(-NCX:NCX,-NCY:NCY,KK)
        REAL  G1(-NCX:NCX,-NCY:NCY,KK)
        REAL  G2(-NCX:NCX,-NCY:NCY,KK)
 
        DO 2011 K=1,KK
          DO 2010 N=-NCY,NCY
            DO 2009 M=-NCX,NCX
              UC(M,N,K)=UC(M,N,K)*(1.0+G1(M,N,K)*AMP-G2(M,N,K))
 2009       CONTINUE
 2010     CONTINUE
 2011   CONTINUE
 
        RETURN
        END
 
 
 
 
C   --- spacialy controled gain ---
        SUBROUTINE GAINS(UC,NCX,NCY,KK,UCM,STDDV,FIXX,SUMC)
        PARAMETER(NCXMAX=28, NCYMAX=9)
        INTEGER   NCX,NCY,STDDV,KK,MUE
        REAL      FIXX,SUMC
        REAL      UC(-NCX:NCX,-NCY:NCY,KK), UCM(KK)
        REAL      GS(-NCXMAX:NCXMAX,-NCYMAX:NCYMAX)
 
        SUMC=0.0
C   --- calculation of GS ---
        MUE= NCX*FIXX
        DO 1000 N=-NCY,NCY
          DO 1001 M=-NCX,NCX
            GS(M,N)=EXP(-REAL(M-MUE)**2/(2.0*STDDV*STDDV))
 1001     CONTINUE
 1000   CONTINUE
 
        DO 1005 K=1,KK
          UCM(K)=0.0
 1005   CONTINUE
 
C   --- multiply GS ---
        DO 1004 K=1,KK
          DO 1002 N=-NCY,NCY
            DO 1003 M=-NCX,NCX
              UUC=UC(M,N,K)*GS(M,N)
              SUMC=SUMC+UUC
              UC(M,N,K)=UUC
              IF(UUC .GT. UCM(K)) UCM(K)=UUC
 1003       CONTINUE
 1002     CONTINUE
 1004   CONTINUE
        RETURN
        END



C   --- calculation of maximum response in U0 ---
        SUBROUTINE U0MAX(UC,UCM,NCX,NCY,KK)
        INTEGER   NCX,NCY,KK,K,M,N
        REAL      UC(-NCX:NCX,-NCY:NCY,KK),UCM(KK)

        DO 1005 K=1,KK
          UCM(K)=0.0
 1005   CONTINUE
 
        DO 1004 K=1,KK
          DO 1002 N=-NCY,NCY
            DO 1003 M=-NCX,NCX
              IF(UC(M,N,K) .GT. UCM(K)) UCM(K)=UC(M,N,K)
 1003       CONTINUE
 1002     CONTINUE
 1004   CONTINUE
        RETURN
        END
 

