
C  RESA ./FBNTE2
C       FBNTE0.FTN  -----  FOR  FBNEO0
C        ***  MODEL FOR SELECTIVE ATTENTION  ***
C        ***  for ASCII data file  ***
C                     for wide version
C         *******************************************************
C           FOR SUN WORKSTATION
C           can be supervized learning; for analogue data
C           ratio btween X & Y can be arbitrary
C           27-MAR-90
C         *******************************************************
 
C       SUBROUTINE CONTRL(LTRAIN,U0,MM,NN,KS,IW,IWC,*)
        SUBROUTINE CONTRL(LTRAIN,FILENUM,U0,MM,NN,KS,
     &                    KTRAIN,MTRA,NTRA,IW,IWC,*)
C        *** RETURN 1:  SAVE COEFF. AND STOP
C        *** IREPTM=0: SIMULATE ONECE
C        *** IREPTM=1: AUTOMATIC PATTERN SELECT  AND SIMULATION
C        *** IREPTM>1: REPEATED AUTMATIC PATTERN SELECT  AND SIMULATION
 
        PARAMETER  (MMCHAR=16, LH=4)
        PARAMETER  (KKMAX=40, KVMAX=5, MMMAX=28, NNMAX=9)
C                                    ! MMMAX=MM  NNMAX=NN
C       *** MMMAX SHOULD BE EQUQL TO MM ***
C       *** NNMAX SHOULD BE EQUQL TO NN ***
        REAL       U0(-MM:MM,-NN:NN)
        INTEGER    IQ(KVMAX,KKMAX)
        INTEGER    MTR(KVMAX,KKMAX)
        INTEGER    NTR(KVMAX,KKMAX)
        INTEGER    IWC(0:LH)
C       IP isn't used because patterns are treated as caracters
C       INTEGER    IP(-NNMAX:NNMAX,KVMAX,KKMAX)
        CHARACTER  IPCHAR(1:MMMAX*2+1,-NNMAX:NNMAX,KVMAX,KKMAX)
C                                                          ! NNMAX=NN
        INTEGER    ERRCODE,FILENUM,NUM1,NUM2,XX,YY,ANALOG,XXX
        CHARACTER  LN(10) /'0','1','2','3','4','5','6','7','8','9'/
        CHARACTER  DNAME*50
        CHARACTER  L
        INTEGER  IU /4/
C                                               ! UNIT NO. FOR DISK
        INTEGER  INIT /1/
        SAVE       KTR,KTRV,KMAX,MTR,NTR
        SAVE       IQ,KSTAR,KVSTAR,KEND,KVEND,IREPT,IREPTM,IPCHAR
        SAVE       XX,YY,ANALOG,XXX
 
C                         ! Flag indicating initial entry to this sub.
        DNAME='fbna  .wdt'

        IF (NN .NE. NNMAX) THEN
           WRITE(*,*) 'Improper parameter NNMAX in sub. CONTRL(NN)'
           WRITE(*,*) 'NN=',NN,' NNMAX=',NNMAX
           STOP
        END IF
        IF (MM .NE. MMMAX)
     &          STOP  'Improper parameter MMMAX in sub. CONTRL(MM)'
 
        NUM2=FILENUM/10
        NUM1=FILENUM-NUM2*10
        DNAME(5:5)=LN(NUM2+1)
        DNAME(6:6)=LN(NUM1+1)

        IF (INIT .EQ. 1)  THEN
C                                ! INITIAL ENTRY TO THIS SUB
          INIT=0
          IF (LTRAIN.EQ.0)  THEN
            KMAX=KKMAX
          ELSE
            KMAX=KS
          END IF
 
C         *** CLEAR DATA AREA ***
          DO 2002 K=1,KKMAX
            DO 2001 KV=1,KVMAX
              IQ(KV,K)=0
              MTR(KV,K)=99
              NTR(KV,K)=99
              DO 2000 N=-NN,NN
                DO 2012 M=1,MMMAX*2+1
                  IPCHAR(M,N,KV,K)=' '
 2012           CONTINUE
 2000         CONTINUE
 2001       CONTINUE
 2002     CONTINUE
 1002     FORMAT(A1)
          L='O'
 
          IF (L .NE. 'N')  THEN
C           *** OPEN AND READ DATA FROM ASCII FILE ***
            OPEN (UNIT=IU, IOSTAT=ERRCODE, ERR=2010, FILE=DNAME,
     &             STATUS='OLD',ACCESS='SEQUENTIAL',FORM='FORMATTED')
            READ (IU,4003) ANALOG,XX,YY,XXX
 4003       FORMAT (4I3)
 4002       FORMAT (5I3/(57A1))
 100        READ (IU,4002,END=110) K,KV,IQ(KV,K),MTR(KV,K),NTR(KV,K),
     &           ((IPCHAR( M, N,KV,K),  M=1,MMMAX*2+1),  N=-NN,NN)
C           WRITE (*,*) 'K=',K,':KV=',KV,':IQ(KV,K)=',IQ(KV,K)
            IF ((K.LT.1).OR.(K.GT.KKMAX) .OR.
     &                  (KV.LT.1).OR.(KV.GT.KVMAX))  THEN
              STOP  'READ ERROR IN PATTERN DATA FILE'
            END IF
            GO TO 100
 110        CLOSE (UNIT=IU)
          END IF
 
          KTR=1
          KTRV=0
          IREPTM=0
        END IF
 
 
C       *** SET DEFAULT FOR THE NEXT PATTERN ***
 200    KTRV=KTRV+1
        IF (KTRV .GT. KVMAX)  THEN
          KTR=KTR+1
          KTRV=1
        END IF
 
 210    IF (IREPTM .EQ. 0)  THEN
C         *** SET SIMULATION MODE ***
          CALL TABLE(IQ, KMAX, KKMAX, KVMAX, LTRAIN)
          WRITE (*,1004)
 1004     FORMAT (,'Modify table(M), Start simulation(S), ',
     &      'Repeat(R), or Stop(/) Write disk(W)
     &       Input pattern(else) ? ===> ')
          READ (*,1002)  L
          IF (L .EQ. 'W')  GO TO 900
          IF (L .EQ. '/')  GO TO 910
          IF ((L.EQ.'S') .OR. (L.EQ.'R'))  THEN
C           *** SET REPETITION TIMES ***
            CALL KREAD(KTR, KTRV, KMAX, KVMAX, LTRAIN,
     &                 'START PATTERN  ', *900)
            KSTAR=KTR
            KVSTAR=KTRV
            KEND=KMAX
C                               ! DEFAULT
            KVEND=KVMAX
C                               ! DEFAULT
            CALL KREAD(KEND, KVEND, KMAX, KVMAX, LTRAIN,
     &                 'END PATTERN    ', *900)
 
            IF (L .EQ. 'S')  THEN
              IREPTM=1
            ELSE
              WRITE (*,1010)
 1010         FORMAT (1X,'REPETITION TIME = ')
              READ (*,1011)  IREPTM
 1011         FORMAT (I3)
            END IF
            IREPT=1
            CALL IWREAD(IW, IWC)
          END IF
        END IF
 
 
        IF (IREPTM .GE. 1)  THEN
          IF ( (KTR.LT.KEND)  .OR.
     &         ((KTR.EQ.KEND).AND.(KTRV.LE.KVEND)) )  THEN
            IF (IQ(KTRV,KTR) .LE. 0)  GO TO 200
 
C           ***  READ PATTERN AND START SIMULATION  ***
            WRITE (*,1003)  KTR, KTRV
 1003       FORMAT ('K=',I2,10X,'KV=',I1)
C           IF (IW.GT.0 .AND. IW.NE.6)  WRITE (IW,1003)  KTR, KTRV
            CALL MPAT(U0, IPCHAR(1,-NN,KTRV,KTR), MM, NN)
            KTRAIN=KTR
            MTRA=MTR(KTRV,KTR)
            NTRA=NTR(KTRV,KTR)
            RETURN
          ELSE
            IF (IREPT .LT. IREPTM)  THEN
C                                          ! REPEAT AGAIN
              IREPT=IREPT+1
              KTR=KSTAR
              KTRV=KVSTAR - 1
              GO TO 200
            END IF
            IREPTM=0
            GO TO 210
C                                        ! END REPETITION
          END IF
 
        ELSE
 
C         *** READ AND MODIFY PATTERN ***
	 IF(L .EQ. 'M') THEN
          CALL KREAD(KTR, KTRV, KMAX, KVMAX, LTRAIN,
     &               'SELECT PATTERN ', *900)
          CALL MPAT(U0, IPCHAR(1,-NN,KTRV,KTR), MM, NN)
         END IF
	 CALL PATEDIT(U0)
         CALL MPATR(U0, IPCHAR(1,-NN,KTRV,KTR), MM, NN)
         IQ(KTRV,KTR)=10
	 IREPTM=1
         RETURN
        END IF
 
C       *** END CONDITION ***
 900    CONTINUE
C           *** SAVE PATTERN-DATA INTO ASCII FILE ***
        write(*,*) 'DNAME,ANALOG,XX,YY,XXX,K,KV=' 
     &             ,DNAME,ANALOG,XX,YY,XXX,K,KV
        OPEN (UNIT=IU, IOSTAT=ERRCODE, ERR=2010, FILE=DNAME,
     &        STATUS='UNKNOWN',ACCESS='SEQUENTIAL', FORM='FORMATTED')
        WRITE(IU,4500) ANALOG,XX,YY,XXX
 4500   FORMAT(4I3)
        DO 2005 K=1,KKMAX
          DO 2004 KV=1,KVMAX
            IF (IQ(KV,K) .GT. 0)  THEN
C             WRITE(*,4002) K,KV,IQ(KV,K),MTR(KV,K),NTR(KV,K),
C    &              ((IPCHAR(M,N,KV,K),  M=1,MMMAX*2+1), N=-NN,NN)
              WRITE(IU,4002) K,KV,IQ(KV,K),MTR(KV,K),NTR(KV,K),
     &              ((IPCHAR(M,N,KV,K),  M=1,MMMAX*2+1), N=-NN,NN)
            END IF
 2004     CONTINUE
 2005   CONTINUE
        CLOSE (UNIT=IU)
 
  910   IF (LTRAIN .EQ. 0)  THEN
          STOP
       ELSE
          WRITE (*,1900)
 1900     FORMAT (1X,'SAVE coeff. ?',
     &               '   YES OR NO(N) ====> ')
          READ (*,1002)  L
          IF (L .EQ. 'N')  THEN
            STOP
          ELSE
            KTRAIN=KTR
            MTRA=MTR(KTRV,KTR)
            NTRA=NTR(KTRV,KTR)
            RETURN 1
          END IF
        END IF
        GOTO 2011
 
 2010   WRITE (*,*) '<CONTRL>OPEN ERR:FILENAME=',DNAME,':CODE=',ERRCODE
        STOP
 
 2011   END
 
 
 
 
 
C    -- Display pattern table --
        SUBROUTINE TABLE(IQ,KK,KKMAX,KVMAX,LTRAIN)
        INTEGER  IQ(KVMAX,KKMAX)
        CHARACTER*1  L(0:19)
        CHARACTER*1  LN(0:10)
     &               /' ','1','2','3','4','5','6','7','8','9','X'/
        WRITE (*,1001) LTRAIN
 1001   FORMAT (5X,'=== PATTERN TABLE ===',5X,'LTRAIN=',I2)
        DO 2002 KM1=1,KK,20
          KM2=MIN0(KM1+19,KK)
          WRITE (*,1002)  (K, K=KM1,KM2)
 1002     FORMAT (5X,20I3)
          DO 2001 N=1,KVMAX
            DO 2000 K=KM1,KM2
              IQQ=IQ(N,K)
              IF (IQQ.LT.0)  IQQ=0
              IF (IQQ.GT.10)  IQQ=10
              L(K-KM1)=LN(IQQ)
 2000        CONTINUE
            WRITE (*,1003) N ,(L(K-KM1) ,K=KM1,KM2)
 1003       FORMAT (1X,I2,3X,20(2X,A1))
 2001     CONTINUE
 2002   CONTINUE
        RETURN
        END
 
 
 
C    -- Input K, KV --
        SUBROUTINE KREAD(K,KV,KMAX,KVMAX,LTRAIN,PROM,*)
        CHARACTER  CRCT, PROM*15
 
C        *** READ K ***
        LTRAIN=LTRAIN
        CRCT=' '
 10     WRITE (*,1001)  CRCT, PROM, K
 1001   FORMAT (A1,A15,18X,'K=',I3,' ====> ')
        READ (*,1002)  KIN
 1002   FORMAT (I2)
        IF (KIN .LT. 0)  RETURN 1
        IF (KIN .EQ. 0)  KIN=K
        IF (KIN .GT. KMAX)  THEN
          CRCT='+'
          GO TO 10
        END IF
        IF (K .NE. KIN)  THEN
          K=KIN
          KV=1
        END IF
 
C        *** READ KV ***
        CRCT=' '
 20     WRITE (*,1003)  CRCT, KV
 1003   FORMAT (A1,5X,'VARIATION ',18X,'KV=',I2,' ====> ')
        READ (*,1002)  KIN
        IF (KIN .LT. 0)  RETURN 1
        IF (KIN .EQ. 0)  KIN=KV
        IF (KIN .GT. KVMAX)  THEN
          CRCT='+'
          GO TO 20
        END IF
        IF (KV .NE. KIN)  KV=KIN
        RETURN
        END
 
 
 
 
 
C    -- Convert bit_image IP to normal_image P --
        SUBROUTINE MPAT(P,IP,MM,NN)

C       PARAMETER  (MMCHAR=16)
        PARAMETER  (MMMAX =28)
        CHARACTER  IP(1:MMMAX*2+1,-NN:NN)
        REAL  P(-MM:MM,-NN:NN)
        CHARACTER  HEX*16 /'0123456789X'/
C
        DO 2001 N=-NN,NN
          DO 2000 M=-MM,MM
            P(M,N)=(INDEX(HEX,IP(M+MM+1,N))-1)*0.1
 2000     CONTINUE
 2001   CONTINUE
 
        RETURN
        END
 
C    -- Convert normal_image P to bit_image IP --
        SUBROUTINE MPATR(P,IP,MM,NN)

C       PARAMETER  (MMCHAR=16)
        PARAMETER  (MMMAX =28)
        CHARACTER  IP(1:MMMAX*2+1,-NN:NN)
        REAL  P(-MM:MM,-NN:NN)
        CHARACTER  HEX*16 /'0123456789X'/
        INTEGER I
C
        DO 2001 N=-NN,NN
          DO 2000 M=-MM,MM
            I=INT(P(M,N)*10)+1
            IP(M+MM+1,N)=HEX(I:I)
 2000     CONTINUE
 2001   CONTINUE
        WRITE(*,4002) ((IP(M,N), M=1,MM*2+1), N=-NN,NN)
 4002   FORMAT(57A1) 
        RETURN

        END
