#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include "font.h"

Display *d;
Window r, w, head,  timew, messw;
GC gc;
XEvent e;
Font f1,f2,f3;

unsigned long intensity[10];

void initw_()
{
        intensity[0]  = MyColor (d, "DarkSlateBlue"    );
        intensity[1]  = MyColor (d, "DodgerBlue"    );
        intensity[2]  = MyColor (d, "DarkTurquoise"    );
        intensity[3]  = MyColor (d, "aquamarine"    );
        intensity[4]  = MyColor (d, "PaleGreen"    );
        intensity[5]  = MyColor (d, "GreenYellow"    );
        intensity[6]  = MyColor (d, "yellow"    );
        intensity[7]  = MyColor (d, "orange"    );
        intensity[8]  = MyColor (d, "coral"    );
        intensity[9]  = MyColor (d, "orangeRed"    );
}

void makewindow_()
{

	unsigned long color_title,color_b,color_f;
	int i, x, y;
	int x0, y0, x1, y1;
        char title1[60],title2[60],str[10];
	d = XOpenDisplay (NULL);
	r = RootWindow (d, 0);
	f1 = XLoadFont (d,times240);
	f2 = XLoadFont (d,helvetica240);
	f3 = XLoadFont (d,times180);
	gc = XCreateGC (d, r, 0, 0);

	color_title = MyColor (d, "red"    );
        color_b = MyColor (d, "black"    );
        color_f = MyColor (d, "white"    );

	w     = XCreateSimpleWindow (d, r,  20,  20, 1100,780, 2,color_f,color_b);
	head  = XCreateSimpleWindow (d, w, 10, 10, 1070, 60, 5,color_f,color_b);
	timew = XCreateSimpleWindow (d, w,560, 20, 140, 40, 5,color_f,color_b);
	messw = XCreateSimpleWindow (d, w,720, 20, 350, 40, 5,color_f,color_b);

        XSelectInput (d, w,     ExposureMask); 
        XSelectInput (d, head,  ExposureMask);
        XSelectInput (d, timew,  ExposureMask);
        XSelectInput (d, messw,  ExposureMask);

	XMapWindow (d, w);
	XMapSubwindows (d, head);
	XMapSubwindows (d, w);

	XNextEvent(d,&e);
        XSetForeground (d, gc, color_title);
        XSetFont (d, gc, f1);
        strcpy(title1,"Character Recognition in Cursive Handwriting.",45);
        strcpy(title2,"by T.Imagawa & K.Fukushima, Osaka University",28);
        XDrawString (d, head, gc,  20, 27, title1,strlen(title1));
        XSetFont (d, gc, f3);
        XDrawString (d, head, gc, 130, 52, title2,strlen(title2));
        XFlush(d);
}

void letter_(x0,y0,size)
int *x0,*y0,*size;
{
	static char *letters={"aeotc"};
	unsigned long color_let;
	int k;

	color_let = MyColor (d, "snow"   );
        XSetForeground (d, gc, color_let);

        XSetFont (d, gc, f1);
	for(k=0;k<5;k++){
  	  XDrawString (d,w,gc,*x0,*y0+*size*2*k,(letters+k),1);
	}
}

void time_(time)
int *time;
{
	char times[15];
	unsigned long color_time;
	int i;

	color_time = MyColor (d, "cyan"   );
        XSetForeground (d, gc, color_time);
        XSetFont (d, gc, f2);
        sprintf(times,"time = %3d",*time);
	XClearWindow (d, timew);
        XDrawString (d, timew, gc,15, 30, times,strlen(times));
        XFlush(d);
	
}

void wast(time)
int time;
{
	int i,j,t;
	for(t=0;t<time;t++){
		for(i=0;i<2000;i++){
			for(j=0;j<100;j++);
		}
	}
}

void mess_(message)
int *message;
{
	unsigned long color_message;

	color_message = MyColor (d, "MediumSpringGreen"   );
        XSetForeground (d, gc, color_message);
        XSetFont (d, gc, f2);
	XClearWindow (d, messw);
        XDrawString (d, messw, gc,15, 30, message,strlen(message));
        XFlush(d);
	wast(50);	
}

void str_(strings,x0,y0)
int *strings,*x0,*y0;
{
	unsigned long color_str;

	color_str = MyColor (d, "LightCyan"   );
        XSetForeground (d, gc, color_str);
        XSetFont (d, gc, f3);
        XDrawString (d, w, gc,*x0,*y0, strings,strlen(strings));
        XFlush(d);
}


void scale_(x0,y0)
int *x0,*y0;
{
	int i,size=20;

	for(i=0;i<10;i++){
	        XSetForeground (d, gc, intensity[9-i]);
		XFillRectangle(d,w,gc,*x0,*y0+size*i,size,size);	
	}
        XFlush(d);
}


void printd_(u,mm,nn,kk,x0,y0,size)
float *u;
int *mm,*nn,*kk,*x0,*y0,*size;
{
	int m,n,k,mw,nw,mn,kh;
	unsigned long color_frame_act,color_wipe;
        float uu,umax,*pu;

	color_frame_act   = MyColor (d, "snow"    );
	color_wipe    = MyColor (d, "black"    );

        mw=2*(*mm)+1; nw=2*(*nn)+1; mn=mw*nw; kh=350/((nw+1)*(*size));
	umax=0.0;

	pu=u;
	for(k=0;k<*kk;k++){
          for(n=0;n<nw;n++){
            for(m=0;m<mw;m++){
              uu=*pu; pu++;
              if(uu>umax) umax=uu;
	    }
          }
        }

        pu=u;
	for(k=0;k<*kk;k++){
          XSetForeground (d, gc, color_frame_act);
	  XDrawRectangle(d,w,gc,*x0+(k/kh)*(mw+2)*(*size)-1,*y0+(k%kh)*(nw+1)*(*size)-1,(*size)*mw+2,(*size)*nw+2);
          XSetForeground (d, gc, color_wipe);
	  XFillRectangle(d,w,gc,*x0+(k/kh)*(mw+2)*(*size),*y0+(k%kh)*(nw+1)*(*size),(*size)*mw,(*size)*nw);
	  for(n=0;n<nw;n++){
	    for(m=0;m<mw;m++){
              uu=(*pu)/umax; pu++;
              if(uu>0.0){
	        XSetForeground (d, gc, intensity[(int)(9.9*uu)]);
	        XFillRectangle(d,w,gc,*x0+(*size)*m+(k/kh)*(mw+2)*(*size),*y0+(*size)*n+(k%kh)*(nw+1)*(*size),*size,*size);
	      }
            }
          }
        }
	XFlush(d);
}

void printrect_(mm,nn,kk,x0,y0,size)
int *mm,*nn,*kk,*x0,*y0,*size;
{
	int k,mw,nw,mn,kh;
        unsigned long color_frame_inact;

        color_frame_inact   = MyColor (d, "RoyalBlue3"    );

        mw=2*(*mm)+1; nw=2*(*nn)+1; mn=mw*nw; kh=350/((nw+1)*(*size));
        for(k=0;k<*kk;k++){
           XSetForeground (d, gc, color_frame_inact);
           XDrawRectangle(d,w,gc,*x0+(k/kh)*(mw+2)*(*size)-1,*y0+(k%kh)*(nw+1)*(*size)-1,(*size)*mw+2,(*size)*nw+2);
       }
        XFlush(d);
}


void clsw_()
{
	XClearWindow (d, w);
}


